"use strict";

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("regenerator-runtime/runtime");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.regexp.split");

require("core-js/modules/es6.object.assign");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

/**
 * * * LOCALE INTL SETTINGS * * *
 * */
var React = require("react");

var _require = require("react-intl"),
    IntlProvider = _require.IntlProvider,
    addLocaleData = _require.addLocaleData;

function load() {
  return _load.apply(this, arguments);
}
/* needed in order to user nested translation objects */


function _load() {
  _load = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee() {
    var _ref, _ref2, module1, module2, module3;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return Promise.all([require("intl"), require("intl/locale-data/jsonp/en"), require("intl/locale-data/jsonp/it"), require("intl/locale-data/jsonp/de")]);

          case 2:
            _ref = _context.sent;
            _ref2 = _slicedToArray(_ref, 3);
            module1 = _ref2[0];
            module2 = _ref2[1];
            module3 = _ref2[2];
            return _context.abrupt("return", [module1, module2, module3]);

          case 8:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return _load.apply(this, arguments);
}

var flattenMessages = function flattenMessages(nestedMessages) {
  var prefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";

  if (!nestedMessages) {
    return {};
  }

  return Object.keys(nestedMessages).reduce(function (messages, key) {
    var value = nestedMessages[key] || "";
    var prefixedKey = prefix ? "".concat(prefix, ".").concat(key) : key;

    if (typeof value === "string") {
      Object.assign(messages, _defineProperty({}, prefixedKey, value));
    } else {
      Object.assign(messages, flattenMessages(value, prefixedKey));
    }

    return messages;
  }, {});
};

var IntlProviderHoc = function IntlProviderHoc(props) {
  // props.localeData is Our translated strings
  var _props$localeData = props.localeData,
      localeData = _props$localeData === void 0 ? {} : _props$localeData,
      _props$initialLocale = props.initialLocale,
      initialLocale = _props$initialLocale === void 0 ? {} : _props$initialLocale;
  var localeToAdd = Object.keys(localeData).map(function (value) {
    return {
      locale: value,
      fields: localeData[value],
      pluralRuleFunction: function pluralRuleFunction() {}
    };
  });
  addLocaleData(localeToAdd); // Define user's language. Different browsers have the user locale defined
  // on different fields on the `navigator` object, so we make sure to account
  // for these different by checking all of them

  var language = initialLocale.length ? initialLocale : navigator.languages && navigator.languages[0] || navigator.language || navigator.userLanguage || "it"; // Split locales with a region code

  var languageWithoutRegionCode = language.toLowerCase().split(/[_-]+/)[0]; // Try full locale, try locale without region code, fallback to 'en'

  var messages = localeData[languageWithoutRegionCode] || localeData[language] || localeData.en; // If browser doesn't support Intl (i.e. Safari), then we manually import
  // the intl polyfill and locale data.

  if (!window.Intl) {
    load();
  }

  return React.createElement(IntlProvider, {
    locale: language,
    key: language,
    messages: flattenMessages(messages)
  }, props.children);
};

module.exports = IntlProviderHoc;
